(function($) {
  
  Drupal.ImportantInformation = {};

  // Toggle the block display.
  Drupal.ImportantInformation.toggle_display = function(){
    $('#block-important-information-important-information .action-links .dismiss').show().click(function(){
      $('body').removeClass('has-important-information');
      $('#block-important-information-important-information').hide();
      $(window).resize();
    });
  }

  // Toggle the block display.
  Drupal.ImportantInformation.toggle_full_screen = function(){
    $('#block-important-information-important-information .action-links .full-screen').show().click(function(){
      if (!$('body').hasClass('important-information-full-screen')) {
        $('body').addClass('important-information-full-screen');
        var $buttonElement = $(this);
        // Replace the title of the block with a specified override.
        if (Drupal.settings.important_information.full_screen_title_override != "") {
          var $titleElement = $('.information-top-bar > h4 > span');
          var originalTitle = $titleElement.html();
          var newTitle = Drupal.settings.important_information.full_screen_title_override;
          if (Drupal.settings.important_information.full_screen_title_override == "(empty)") { 
            newTitle = "";
          }
          $titleElement.attr('data-original-title', originalTitle).html(newTitle);
        }
        // Replace the button contents.
        if ($buttonElement.attr('full-screen-open-text') != "") {
          $buttonElement
            .attr('full-screen-text', $buttonElement.html())
            .html($buttonElement.attr('full-screen-open-text'));
        }
        var oriFAClass = $buttonElement.attr('ori-fa-class');
        var backFAClass = $buttonElement.attr('back-fa-class');
        $buttonElement.removeClass(oriFAClass).addClass(backFAClass).addClass('clicked');
      } else {
        $('body').removeClass('important-information-full-screen');
        var $buttonElement = $(this);
        // Replace the title of the block with a specified override.
        if (Drupal.settings.important_information.full_screen_title_override != "") {
          var $titleElement = $('.information-top-bar > h4 > span');
          var originalTitle = $titleElement.attr('data-original-title');
          $titleElement.html(originalTitle);
        }
        // Replace the button contents.
        if ($buttonElement.attr('full-screen-open-text') != "") {
          $buttonElement
            .html($buttonElement.attr('full-screen-text'));
        }
        var oriFAClass = $(this).attr('ori-fa-class');
        var backFAClass = $(this).attr('back-fa-class');
        $buttonElement.removeClass(backFAClass).addClass(oriFAClass).removeClass('clicked');
      }
      $(window).resize();
    });
  }

  Drupal.ImportantInformation.is_scrolled_into_view = function (element) {
    var docViewTop = $(window).scrollTop();
    var docViewBottom = docViewTop + $(window).height();
    var elemTop = $(element).offset().top;
    var elemBottom = elemTop + $(element).height();
    return ((elemBottom <= docViewBottom) && (elemTop >= docViewTop));
  }

  Drupal.ImportantInformation.toggle_relative_position = function (set_relative, set_auto_height = false) {
    var isiSelector = '#block-important-information-important-information';
    var $element = $(isiSelector);
    if (set_relative) {
      $element
        .css('width','100%')
        .css('position','relative')
        .css('bottom','0')
        .css('top','0')
        .css('left','0')
        .addClass('inline-element');
      if (Drupal.ImportantInformation.isiShowHeight == undefined || Drupal.ImportantInformation.isiShowHeight == "") {
        Drupal.ImportantInformation.isiShowHeight = $(window).scrollTop();
      }
      if (set_auto_height) {
        $element.css('height','auto');
      }
      $('body').removeClass('has-important-information');
    } else if ($element.attr('data-width') != "" 
    && Drupal.ImportantInformation.isiShowHeight > $(window).scrollTop()) {
      Drupal.ImportantInformation.isiShowHeight = "";
      $element
        .css('width','')
        .css('height','')
        .css('position','')
        .css('bottom','')
        .css('top','')
        .css('left','')
        .removeClass('inline-element');
      $('body').addClass('has-important-information');
    }
  }

  Drupal.behaviors.importantInformationModule = {
    attach: function(context, settings) {
      $('#block-important-information-important-information .action-links .dismiss', context).once('dismiss-important-information', function() {
        // Dismiss important information.
        if (settings.important_information.enable_dismiss == 1) {
          Drupal.ImportantInformation.toggle_display();
        }
      });
      $('#block-important-information-important-information .action-links .full-screen', context).once('full-screen-important-information', function() {
        // Full screen important information.
        if (settings.important_information.enable_full_screen == 1) {
          Drupal.ImportantInformation.toggle_full_screen();
        }
      });
      $('#block-important-information-important-information', context).once('important-information-block', function() {
        // Full screen important information.
        if (settings.important_information.enable_inline_bottom == 1) {
          var isiSelector = '#block-important-information-important-information';
          $(window).scroll(function() {
            var $element = $(isiSelector);
            if (Drupal.ImportantInformation.is_scrolled_into_view(settings.important_information.inline_bottom_selector)) {
              Drupal.ImportantInformation.toggle_relative_position(true, true);
            } else if ($element.attr('data-width') != "" 
            && Drupal.ImportantInformation.isiShowHeight > $(window).scrollTop()) {
              Drupal.ImportantInformation.toggle_relative_position(false);
            }
          });
        }
      });
    }
  };
  
  })(jQuery);
  